# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/ajinabraham/njsscan/blob/master/njsscan/rules/semantic_grep/eval/eval_deserialize.yaml
# hash: e7a0a61
# yamllint enable
---
rules:
- id: "rules_lgpl_javascript_eval_rule-serializetojs-deserialize"
  patterns:
  - pattern-either:
    - pattern: |
        require('serialize-to-js').deserialize(...)
    - pattern-inside: |
        $MOD = require('serialize-to-js')
        ...
    - pattern-inside: |
        import $MOD from 'serialize-to-js'
        ...
  - pattern: |
      $MOD.deserialize(...)
  message: |
    User controlled data in 'unserialize()' or 'deserialize()' function can result in Object Injection or Remote Code Injection.
  languages:
  - "javascript"
  - "typescript"
  severity: "ERROR"
  metadata:
    owasp: "A8:2017-Insecure Deserialization"
    cwe: "CWE-502: Deserialization of Untrusted Data"
    security-severity: "CRITICAL"
